import sys, math
from random import random
from collections import Counter

filename = sys.argv[1]
window = int(sys.argv[2])

word_weights = {}

for i in range(3, len(sys.argv)):
    word_weights[sys.argv[i]] = Counter()

word_counts = Counter()
total_words = 0

for line in open(sys.argv[1]):
    tokens = line.split()
    total_words += len(tokens)
    for token in tokens:
        word_counts[token] += 1
        
sampling_distribution = {}
for word in word_counts.keys():
    score = float(word_counts[word]) / (0.0001 * total_words)
    sampling_distribution[word] = (1.0 + math.sqrt(score)) / score

for line in open(sys.argv[1]):
    tokens = filter(lambda w: random() < sampling_distribution[w], line.split())
    #tokens = line.split()

    for i in range(len(tokens)):
        if not tokens[i] in word_weights:
            continue
        
        start = max(i - window, 0)
        end = min(i + window, len(tokens))
        
        for j in range(start, i):
            word_weights[tokens[i]][tokens[j]] += (window + 1) - (i - j)
        for j in range(i+1, end+1):
            word_weights[tokens[i]][tokens[j]] += (window + 1) - (j - i)
            
for word in word_weights.keys():
    for pair in word_weights[word].most_common(50):
        print "{0}\t{1}\t{2}".format(word, pair[0], pair[1])

